Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
BamCacheRecord Class Reference

An instance of this class is written to the front of a Bam or Txo file to make the file a cached instance of some other loadable resource. More...

`#include "bamCacheRecord.h"`

Inheritance diagram for BamCacheRecord:

## Public Member Functions
void | add_dependent_file (const Filename &pathname)
| Adds the indicated file to the list of files that will be loaded to generate the data in this record.
void | add_dependent_file (const VirtualFile *file)
| Variant of add_dependent_file that takes an already opened VirtualFile.
void | clear_data ()
void | clear_dependent_files ()
| Empties the list of files that contribute to the data in this record.
bool | dependents_unchanged () const
| Returns true if all of the dependent files are still the same as when the cache was recorded, false otherwise.
bool | extract_data (TypedWritable *&ptr, ReferenceCount *&ref_ptr)
| Fills ptr and ref_ptr with the two different-typed pointers to the same object, the data stored within this record.
virtual TypeHandle | force_init_type ()
const Filename & | get_cache_filename () const
TypedWritable * | get_data () const
const Filename & | get_dependent_pathname (int n) const
int | get_num_dependent_files () const
time_t | get_recorded_time () const
const Filename & | get_source_pathname () const
time_t | get_source_timestamp () const
virtual TypeHandle | get_type () const
bool | has_data () const
bool | operator== (const BamCacheRecord &other) const
void | output (std::ostream &out) const
| PT (BamCacheRecord) make_copy() const
void | set_data (TypedWritable *ptr)
void | set_data (TypedWritable *ptr, int dummy)
void | set_data (TypedWritable *ptr, ReferenceCount *ref_ptr)
void | set_data (TypedWritableReferenceCount *ptr)
void | write (std::ostream &out, int indent_level=0) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type BamCacheRecord.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| clear_data
| get_cache_filename
| get_data
| Returns a pointer to the data stored in the record, or NULL if there is no data.
| get_recorded_time
| get_source_pathname
| get_source_timestamp
| has_data
| set_data
| Stores a new data object on the record.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Friends
class | BamCache
class | BamCacheIndex
class | BamCacheRecord::SortByAccessTime

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

An instance of this class is written to the front of a Bam or Txo file to make the file a cached instance of some other loadable resource.

This record contains information needed to test the validity of the cache.

Definition at line 35 of file bamCacheRecord.h.

## Constructor & Destructor Documentation

## ◆ ~BamCacheRecord()

BamCacheRecord::~BamCacheRecord | ( |  | ) |
| virtual

Definition at line 74 of file bamCacheRecord.cxx.

## Member Function Documentation

## ◆ add_dependent_file() [1/2]

void BamCacheRecord::add_dependent_file | ( | const Filename & | pathname | ) |

Adds the indicated file to the list of files that will be loaded to generate the data in this record.

This should be called once for the primary source file, and again for each secondary source file, if any.

Definition at line 146 of file bamCacheRecord.cxx.

References VirtualFileSystem::get_global_ptr(), and Filename::make_absolute().

## ◆ add_dependent_file() [2/2]

void BamCacheRecord::add_dependent_file | ( | const VirtualFile * | file | ) |

Variant of add_dependent_file that takes an already opened VirtualFile.

Definition at line 174 of file bamCacheRecord.cxx.

References VirtualFile::get_file_size(), VirtualFile::get_timestamp(), and Filename::make_absolute().

## ◆ clear_dependent_files()

void BamCacheRecord::clear_dependent_files | ( |  | ) |

Empties the list of files that contribute to the data in this record.

Definition at line 136 of file bamCacheRecord.cxx.

## ◆ dependents_unchanged()

bool BamCacheRecord::dependents_unchanged | ( |  | ) | const

Returns true if all of the dependent files are still the same as when the cache was recorded, false otherwise.

Definition at line 83 of file bamCacheRecord.cxx.

References VirtualFileSystem::get_global_ptr().

## ◆ extract_data()

bool BamCacheRecord::extract_data | ( | TypedWritable *& | ptr,
|  | ReferenceCount *& | ref_ptr )
| inline

Fills ptr and ref_ptr with the two different-typed pointers to the same object, the data stored within this record.

This transfers ownership of the data pointer; the caller will be responsible for managing the reference counts on this object subsequently.

Returns true if the record contained any data (and the pointers have been filled), false if it didn't (and the pointers are NULL).

Definition at line 133 of file bamCacheRecord.I.

## ◆ force_init_type()

virtual TypeHandle BamCacheRecord::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 138 of file bamCacheRecord.h.

## ◆ get_class_type()

static TypeHandle BamCacheRecord::get_class_type | ( |  | ) |
| inline static

Definition at line 127 of file bamCacheRecord.h.

## ◆ get_type()

virtual TypeHandle BamCacheRecord::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 135 of file bamCacheRecord.h.

## ◆ init_type()

static void BamCacheRecord::init_type | ( |  | ) |
| inline static

Definition at line 130 of file bamCacheRecord.h.

## ◆ output()

void BamCacheRecord::output | ( | std::ostream & | out | ) | const

Definition at line 192 of file bamCacheRecord.cxx.

## ◆ register_with_read_factory()

void BamCacheRecord::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type BamCacheRecord.

Definition at line 257 of file bamCacheRecord.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libputil().

## ◆ write()

void BamCacheRecord::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const

Definition at line 200 of file bamCacheRecord.cxx.

## ◆ write_datagram()

void BamCacheRecord::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 266 of file bamCacheRecord.cxx.

References Datagram::add_string(), Datagram::add_uint16(), Datagram::add_uint32(), Datagram::add_uint64(), and TypedWritable::write_datagram().

## Friends And Related Symbol Documentation

## ◆ BamCache

friend class BamCache
| friend

Definition at line 143 of file bamCacheRecord.h.

## ◆ BamCacheIndex

friend class BamCacheIndex
| friend

Definition at line 144 of file bamCacheRecord.h.

## ◆ BamCacheRecord::SortByAccessTime

friend class BamCacheRecord::SortByAccessTime
| friend

Definition at line 145 of file bamCacheRecord.h.

## Member Data Documentation

## ◆ clear_data

BamCacheRecord::clear_data

Definition at line 77 of file bamCacheRecord.h.

## ◆ get_cache_filename

BamCacheRecord::get_cache_filename

Definition at line 56 of file bamCacheRecord.h.

## ◆ get_data

TypedWritable * BamCacheRecord::get_data
| inline

Returns a pointer to the data stored in the record, or NULL if there is no data.

The pointer is not removed from the record.

Definition at line 77 of file bamCacheRecord.h.

## ◆ get_recorded_time

BamCacheRecord::get_recorded_time

Definition at line 58 of file bamCacheRecord.h.

## ◆ get_source_pathname

BamCacheRecord::get_source_pathname

Definition at line 55 of file bamCacheRecord.h.

## ◆ get_source_timestamp

BamCacheRecord::get_source_timestamp

Definition at line 57 of file bamCacheRecord.h.

## ◆ has_data

BamCacheRecord::has_data

Definition at line 77 of file bamCacheRecord.h.

## ◆ set_data

void BamCacheRecord::set_data
| inline

Stores a new data object on the record.

This variant on set_data() is provided just to allow Python code to pass a 0 as the second parameter.

This variant on set_data() is provided to easily pass objects deriving from TypedWritableReferenceCount.

This variant on set_data() is provided to easily pass objects deriving from TypedWritable.

You should pass the same pointer twice, to both parameters; this allows the C++ typecasting to automatically convert the pointer into both a TypedWritable and a ReferenceCount pointer, so that the BamCacheRecord object can reliably manage the reference counts.

You may pass 0 or NULL as the second parameter. If you do this, the BamCacheRecord will not manage the object's reference count; it will be up to you to ensure the object is not deleted during the lifetime of the BamCacheRecord object.

Definition at line 77 of file bamCacheRecord.h.

The documentation for this class was generated from the following files:

- panda/src/putil/bamCacheRecord.h
- panda/src/putil/bamCacheRecord.cxx
- panda/src/putil/bamCacheRecord.I